from typing import Any, Dict, List, Type, TypeVar, Union

import attr

from ..types import UNSET, Unset

T = TypeVar("T", bound="LiveDataOrigin")


@attr.s(auto_attribs=True)
class LiveDataOrigin:
    """
    Attributes:
        discriminator (str):
        live_data_id (Union[Unset, str]):
    """

    discriminator: str
    live_data_id: Union[Unset, str] = UNSET
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        discriminator = self.discriminator
        live_data_id = self.live_data_id

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "discriminator": discriminator,
            }
        )
        if live_data_id is not UNSET:
            field_dict["liveDataId"] = live_data_id

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        discriminator = d.pop("discriminator")

        live_data_id = d.pop("liveDataId", UNSET)

        live_data_origin = cls(
            discriminator=discriminator,
            live_data_id=live_data_id,
        )

        live_data_origin.additional_properties = d
        return live_data_origin

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
